/* Screen and .gle driver for pc */
#include "all.h"
#include "vdevice.h"
#if (defined DJ || defined EMXOS2)
        extern int draw_circle(void);
#endif
#define false 0
#define true (!false)
#define SOLID_LINE 1
#define DASHED_LINE 2
#include <math.h>
#include "mygraph.h"
#include "justify.h"
/*---------------------------------------------------------------------------*/
#define pi 3.141592653
#define true (!false)
int getch(void);
int kbhit(void);

int get_markeri(char *s);
char *strupr(char *s);


extern int gle_nspeed;
extern int gle_speed;
extern int nobigfile;
/*---------------------------------------------------------------------------*/
/* The global variables for the PC screen driver */
/*-----------------------------------------------*/

float v_scale, v_xscale, v_yscale;
char *gledir(char *s);
int v_graphmode;
int v_fillstyle=1,v_fillcolor;
int vv_lstyle,v_lwidth;
int v_maxy;
static int ee;
FILE *gf;
extern char input_file[];
char *bgidir();
/*---------------------------------------------------------------------------*/

void v_open(float width, float height)
{
        static int g_driver,g_error;
        float f;
        char bigfile[80];
        char glefile[80];

#ifdef EMXOS2                                           /* a.r. */
        extern char outputName[80];

        (void) strcpy(bigfile,outputName);
#else        
        (void) strcpy(bigfile,input_file);
#endif
        if (strchr(bigfile,'.')==NULL) {
                gprint("Error in file name,  {%s} \n",input_file);
                (void) gle_abort("error in file name \n");
        }
        *strchr(bigfile,'.') = 0;
        (void) strcpy(glefile,bigfile);
        (void) strcat(glefile,".gle");
        (void) strcat(bigfile,".big");
        gf = fopen(glefile,"r");
        if (gf==NULL) { /* then it doesn't exist, so lets create it */
                gf = fopen(glefile,"w");
                if (gf==NULL) gprint("Failed to create {%s} \n",glefile);
                else {
                        (void) fprintf(gf,"size 24 18\n");
                        (void) fprintf(gf,"bigfile %s\n",bigfile);
                        (void) fclose(gf);
                }
        } else (void) fclose(gf);

        if (!nobigfile)
        {
                gf = fopen(bigfile,"w");
                if (gf==NULL) {
                        gprint("Unable to open output gle file out.gle\n");
                        (void) text_inkey();
                        abort();
                }
        }
        gle_nspeed = 2;
        (void) g_open(width,height);
}
/*---------------------------------------------------------------------------*/
void v_close(void)
{
#ifndef EMXOS2
        (void) g_close();
        (void) fclose(gf);
#else
        if (!nobigfile) (void) fclose(gf);
        (void) g_close();
#endif
}
/*---------------------------------------------------------------------------*/

void v_lstyle(char *s)
{
        if (*s == 0) s = "1";
        vv_lstyle = DASHED_LINE;
        if (strcmp(s,"")==0) vv_lstyle = SOLID_LINE;
        if (strcmp(s,"1")==0) vv_lstyle = SOLID_LINE;
        (void) g_set_line_style(s);
        if (!nobigfile) (void) fprintf(gf,"set lstyle %s\n",s);
}
/*---------------------------------------------------------------------------*/

void v_line(float zx,float zy)
{
        (void) g_line(zx,zy);
        if (!nobigfile) (void) fprintf(gf,"aline %g %g \n",zx,zy);
}

void v_move(float zx,float zy)
{
        (void) g_move(zx,zy);
        if (!nobigfile) (void) fprintf(gf,"amove %g %g \n",zx,zy);
}
/*---------------------------------------------------------------------------*/

void v_gsave()
{
        (void) g_gsave();
        if (!nobigfile) (void) fprintf(gf,"gsave \n");
}

void v_grestore()
{
        (void) g_grestore();
        if (!nobigfile) (void) fprintf(gf,"grestore \n");
}

void v_text(char *s)
{
        (void) g_text(s);
        if (!nobigfile) (void) fprintf(gf,"text %s \n",s);
}

double cur_hei;
void v_set_hei(float g)
{
        (void) g_set_hei(g);
        cur_hei = g;
        if (!nobigfile) (void) fprintf(gf,"set hei %g\n",g);
}

void v_set_just(char *s)
{
        if (strcmp(s,"RC")==0) (void) g_set_just(JUST_RC);
        if (strcmp(s,"TC")==0) (void) g_set_just(JUST_TC);
        if (strcmp(s,"BC")==0) (void) g_set_just(JUST_BC);
        if (strcmp(s,"CC")==0) (void) g_set_just(JUST_CC);
        if (strcmp(s,"LEFT")==0) (void) g_set_just(JUST_LEFT); 
        if (!nobigfile) (void) fprintf(gf,"set just %s\n",s);
}

void v_rotate(float g)
{
        (void) g_rotate(g);
        if (!nobigfile) (void) fprintf(gf,"rotate %g \n",g);
}

void v_marker(char *m)
{
#if (!(defined DJ || defined EMXOS2))
        int i;
        i = get_markeri(m);
        (void) g_marker(i,cur_hei);
#else
        draw_circle();
#endif
        if (!nobigfile) (void) fprintf(gf,"marker %s\n",m);
}

#include "global.h"
int32 gt_firstval(OPKEY lkey,char *s);
void v_color(char *s)
{
  char black[10];
        int i;
        i = 0;
        if (*s == 0) {(void) strcpy(black,"BLACK"); s = black;}
        (void) strupr(s);
        (void) g_set_color(gt_firstval(&op_color_typ,s));
        if (!nobigfile) (void) fprintf(gf,"set color %s\n",s);
}

int32 gt_firstval(OPKEY lkey,char *s)
{
        int nk,i,width=0,p;
        for (i=0; (*lkey)[i].typ!=typ_end; i++) {
                p = (*lkey)[i].pos;
                if (p>width) width = p ;
        }
        nk = i;
        for (i=0; i<nk; i++) {
                if (strcmp((*lkey)[i].name,s)==0) {
                        return (*lkey)[i].idx;
                }
        }
/* There was no default return value here in case the loop
immediately above didn't come back with something, send back zero
by default, but that may not be the best choice...*/
	return 0;
}

int get_markeri(char *s)
{
        int i;
        int32 f=0;
        /* if 0, maybe its a user defined marker, ie a subroutine */
        /* Use -ve to signify subroutine instead of normal marker */
        f = gt_firstval(&op_marker,s);
        return f;
}

